import { CompoundFn } from "./compound";
import { Eny, EnyToGuard } from "./utils";
export declare type Flagged<E extends Eny, Name extends string, Value extends {}> = EnyToGuard<E> & {
    flags: Map<Name, Value>;
};
export declare type GetFlagOptions<Name extends keyof vality.flags, F = vality.flags[Name]> = F extends (...args: any[]) => Flagged<infer Type, any, infer Value> ? [Value, Type] : F extends (...args: any[]) => (...args: any[]) => Flagged<infer Type, any, infer Value> ? [Value, Type] : never;
export declare function flag<Name extends keyof vality.flags, Value extends GetFlagOptions<Name>[0], Type extends GetFlagOptions<Name>[1]>(name: Name, value: Value, fn: (e: Type) => CompoundFn<Type, {}>): (e: Type) => Flagged<Type, Name, Value>;
//# sourceMappingURL=flag.d.ts.map