import { RSA } from "./utils";
import { FnArgs, Guard, Valit, ValitParameters } from "./valit";
export declare type Scalar<Name, Type, Options extends RSA = never> = Valit<Name, Type, Options, false>;
declare type GetScalarOptions<Name extends keyof vality.scalars, P = vality.scalars[Name]> = P extends Scalar<any, infer Type, infer Options> ? [Type, Options] : P extends (...args: any[]) => Scalar<any, infer Type, infer Options> ? [Type, Options] : never;
export interface ScalarFn<BaseType, Options, ValueType = unknown, NewType = BaseType> {
    (...args: FnArgs<NewType, Options, ValueType>): NewType | undefined;
}
export declare function scalar<Name extends keyof vality.scalars, Type extends GetScalarOptions<Name>[0], Options extends GetScalarOptions<Name>[1]>(...[name, scalarFn, handleOptions, defaultOptions]: ValitParameters<Name, Type, Options, ScalarFn<Type, Options>>): Valit<Name, Type, Options, false>;
declare type GetScalars<S> = S extends (...args: any[]) => infer R ? R : S;
export declare function extendScalar<Base extends GetScalars<vality.scalars[keyof vality.scalars]>, BaseType extends Base extends Guard<any, infer Type, any> ? Type : never>(base: Base): <Name extends keyof vality.scalars, Type extends GetScalarOptions<Name, vality.scalars[Name]>[0], Options extends GetScalarOptions<Name, vality.scalars[Name]>[1]>(name: Name, fn: ScalarFn<BaseType, Options, BaseType, Type>, handleOptions?: { [K in string & keyof Options]?: ((val: Type, o: NonNullable<Options[K]>, options: import("./valit").CallOptions<Type, Options> & Pick<Options, K>, context: import("./validate").Context) => boolean) | undefined; } | undefined, defaultOptions?: Partial<Options> | undefined) => Valit<Name, Type, Options, false>;
export {};
//# sourceMappingURL=scalar.d.ts.map