import { Parse } from "./parse";
import { Guard, GuardFn } from "./valit";
export interface RSA {
    [K: string]: any;
}
export interface RSE {
    [K: string]: Eny;
}
export declare type Primitive = string | number | boolean | null;
export declare type Eny = Guard<any, any, any> | readonly TOrGuard<Eny>[] | Primitive | RSE;
export declare type EnyToGuard<T> = T extends Guard<any, any, any> ? T : T extends (() => infer U extends Eny) ? EnyToGuard<U> : T extends readonly [TOrGuard<Eny>] ? Guard<"array", T, true> : T extends Primitive ? string extends T ? Guard<"string", T, false> : number extends T ? Guard<"number", T, false> : boolean extends T ? Guard<"boolean", T, false> : null extends T ? Guard<"null", T, false> : Guard<"literal", T, false> : T extends EnumOfTOrGuard<infer U extends Eny> ? Guard<"enum", U, true> : T extends RSE ? Guard<"object", T, true> : never;
export declare function enyToGuard<E extends Eny>(eny: E): Guard<any, any, any>;
export declare function enyToGuardFn<E extends Eny>(e: E): GuardFn<any>;
export declare function getFlags(e: Eny): ReadonlyMap<string, unknown>;
export declare type OneOrEnumOfTOrGuard<T> = TOrGuard<T> | EnumOfTOrGuard<T>;
declare type EnumOfTOrGuard<T> = readonly [
    OneOrEnumOfTOrGuard<T>,
    OneOrEnumOfTOrGuard<T>,
    ...OneOrEnumOfTOrGuard<T>[]
];
declare type TOrGuard<T> = T | Guard<any, T, false> | Guard<any, OneOrEnumOfTOrGuard<T>, true>;
declare type Intersect<T> = (T extends any ? (x: T) => 0 : never) extends (x: infer R) => 0 ? R : never;
declare type TupleKeys<T extends any[]> = Exclude<keyof T, keyof []>;
declare type Foo<T extends any[]> = {
    [K in TupleKeys<T>]: {
        foo: Parse<T[K]>;
    };
};
declare type Values<T> = T[keyof T];
declare type Unfoo<T> = T extends {
    foo: any;
} ? T["foo"] : never;
export declare type IntersectItems<T extends any[]> = Unfoo<Intersect<Values<Foo<T>>>>;
export {};
//# sourceMappingURL=utils.d.ts.map