import { Flagged } from "./flag";
import { Eny } from "./utils";
declare global {
    namespace vality {
        interface flags {
            optional: <E extends Eny>(e: E) => Flagged<E, "optional", true>;
            from: <F extends string>(key: F) => <E extends Eny>(e: E) => Flagged<E, "from", F>;
            virtual: <E extends Eny>(e: E) => Flagged<E, "virtual", true>;
        }
    }
}
//# sourceMappingURL=flags.d.ts.map